org.eclipse.jface.layout

## Class AbstractColumnLayout

- java.lang.Object
- - org.eclipse.swt.widgets.Layout
  - - org.eclipse.jface.layout.AbstractColumnLayout

Direct Known Subclasses:
  TableColumnLayout, TreeColumnLayout

    public abstract class AbstractColumnLayout
    extends Layout

The AbstractColumnLayout is a `Layout` used to set the size of a table in a consistent way even during a resize unlike a `TableLayout` which only sets initial sizes.

You can only add the layout to a container whose only child is the table/tree control you want the layouts applied to.

Since:
  3.4

### Field Summary

Fields
`protected static String` `LAYOUT_DATA` Key used to restore the layout data in the columns data-slot

### Constructor Summary

Constructors
Constructor and Description
`AbstractColumnLayout()` Creates a new abstract column layout.
`AbstractColumnLayout(boolean adjustForScrollBar)` Creates a new abstract column layout.

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`protected Point` `computeSize(Composite composite, int wHint, int hHint, boolean flushCache)` Computes and returns the size of the specified composite's client area according to this layout.
`protected abstract int` `getColumnCount(Scrollable tableTree)` Get the number of columns for the receiver.
`protected int` `getColumnTrim()` The number of extra pixels taken as horizontal trim by the table column.
`protected abstract ColumnLayoutData` `getLayoutData(Scrollable tableTree, int columnIndex)` Get the layout data for a column
`protected void` `layout(Composite composite, boolean flushCache)` Lays out the children of the specified composite according to this layout.
`void` `setColumnData(Widget column, ColumnLayoutData data)` Adds a new column of data to this table layout.
`protected abstract void` `setColumnWidths(Scrollable tableTree, int[] widths)` Set the widths of the columns.
`protected abstract void` `updateColumnData(Widget column)` Update the layout data for a column

### Methods inherited from class org.eclipse.swt.widgets.Layout

`flushCache`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### LAYOUT_DATA

    protected static final String LAYOUT_DATA

Key used to restore the layout data in the columns data-slot

Since:
  3.5
See Also:
  Constant Field Values

### Constructor Detail

#### AbstractColumnLayout

    public AbstractColumnLayout()

Creates a new abstract column layout.

#### AbstractColumnLayout

    public AbstractColumnLayout(boolean adjustForScrollBar)

Creates a new abstract column layout.

Parameters:
  `adjustForScrollBar` - `true` if the layout should reserve space for the vertical scroll bar
Since:
  3.12

### Method Detail

#### setColumnData

    public void setColumnData(Widget column,
                              ColumnLayoutData data)

Adds a new column of data to this table layout.

Parameters:
  `column` - the column
  `data` - the column layout data

#### computeSize

    protected Point computeSize(Composite composite,
                                int wHint,
                                int hHint,
                                boolean flushCache)

Description copied from class: `Layout`
Computes and returns the size of the specified composite's client area according to this layout.

This method computes the size that the client area of the composite must be in order to position all children at their preferred size inside the composite according to the layout algorithm encoded by this layout.

When a width or height hint is supplied, it is used to constrain the result. For example, if a width hint is provided that is less than the width of the client area, the layout may choose to wrap and increase height, clip, overlap, or otherwise constrain the children.

Specified by:
  `computeSize` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `wHint` - width (`SWT.DEFAULT` for preferred size)
  `hHint` - height (`SWT.DEFAULT` for preferred size)
  `flushCache` - `true` means flush cached layout values
Returns:
  a point containing the computed size (width, height)
See Also:
  `Layout.layout(org.eclipse.swt.widgets.Composite, boolean)`, `Control.getBorderWidth()`, `Control.getBounds()`, `Control.getSize()`, `Control.pack(boolean)`, "computeTrim, getClientArea for controls that implement them"

#### layout

    protected void layout(Composite composite,
                          boolean flushCache)

Description copied from class: `Layout`
Lays out the children of the specified composite according to this layout.

This method positions and sizes the children of a composite using the layout algorithm encoded by this layout. Children of the composite are positioned in the client area of the composite. The position of the composite is not altered by this method.

When the flush cache hint is true, the layout is instructed to flush any cached values associated with the children. Typically, a layout will cache the preferred sizes of the children to avoid the expense of computing these values each time the widget is laid out.

When layout is triggered explicitly by the programmer the flush cache hint is true. When layout is triggered by a resize, either caused by the programmer or by the user, the hint is false.

Specified by:
  `layout` in class `Layout`
Parameters:
  `composite` - a composite widget using this layout
  `flushCache` - `true` means flush cached layout values

#### getColumnCount

    protected abstract int getColumnCount(Scrollable tableTree)

Get the number of columns for the receiver.

Parameters:
  `tableTree` - the control
Returns:
  the number of columns
Since:
  3.5

#### setColumnWidths

    protected abstract void setColumnWidths(Scrollable tableTree,
                                            int[] widths)

Set the widths of the columns.

Parameters:
  `tableTree` - the control
  `widths` - the widths of the column
Since:
  3.5

#### getLayoutData

    protected abstract ColumnLayoutData getLayoutData(Scrollable tableTree,
                                                      int columnIndex)

Get the layout data for a column

Parameters:
  `tableTree` - the control
  `columnIndex` - the column index
Returns:
  the layout data, might not null
Since:
  3.5

#### updateColumnData

    protected abstract void updateColumnData(Widget column)

Update the layout data for a column

Parameters:
  `column` - the column
Since:
  3.5

#### getColumnTrim

    protected int getColumnTrim()

The number of extra pixels taken as horizontal trim by the table column. To ensure there are N pixels available for the content of the column, assign N+COLUMN_TRIM for the column width.

Returns:
  the trim used by the columns
Since:
  3.4